% THINGS THAT ARE KNOWN FROM KAPPA FILE AND COMPLX OPTIONS;
% 
% init - the initial abundances of each fragment 
% tinit - the initial simulation time (likely 0) 
% tend - the final simulation time 
% initialstep - initial time step at the beginning of numerical integration
% num_t_point - the number of time points to return 

tinit=0;
tend=1;
initialstep=1e-06;
num_t_point=1000;

global k 
k = [
1,     %%Auto_1
1,     %%Auto_2
1,     %%Auto_3
1,     %%Auto_4
1,     %%Auto_5
1,     %%Auto_6
1,     %%Auto_7
1,     %%Auto_8
1,     %%Auto_9
1,     %%Auto_10
1,     %%Auto_11
1,     %%Auto_12
1,     %%Auto_13
1,     %%Auto_14
1,     %%Auto_15
1,     %short
1,     %%Auto_17
1,     %%Auto_18
1,     %%Auto_19
1,     %long
1,     %%Auto_21
1,     %%Auto_22
1,     %%Auto_23
1,     %%Auto_24
1,     %%Auto_25
1,     %%Auto_26
1,     %%Auto_27
1,     %%Auto_28
1,     %%Auto_29
1,     %%Auto_30
1,     %%Auto_31
1,     %%Auto_32
1,     %%Auto_33
1,     %%Auto_34
1,     %%Auto_35
1,     %%Auto_36
1,     %%Auto_37
1,     %%Auto_38
1,     %%Auto_39
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1,     %[EGFR(Y48!0),SHC(Y7!1,pi!0),GRB2(a!1,b!2),SOS(d!2)]
1      %[EGFR(Y68!0),GRB2(a!0,b!1),SOS(d!1)]
];

global init 
init = [
1000    %EGFR(Y48~u,Y68~u,l,r),EGF(r),EGFR(Y48~u,Y68~u,l,r),EGF(r),GRB2(a,b),SOS(d),GRB2(a,b),SHC(Y7~u,pi)
];

global perturbation_trigger 
perturbation_trigger = [
1, %perturbation 1
];




options = odeset('RelTol', 1e-3, ...
                 'AbsTol', 1e-3, ...
                 'InitialStep', initialstep, ...
                 'MaxStep', tend, ...
                 'Jacobian', @egfr_plx_ODE_system_jacobian);

uiIsOctave = false;
uiIsMatlab = false;
LIC = license('inuse');
for elem = 1:numel(LIC)
   envStr = LIC(elem).feature;
   if strcmpi(envStr,'octave')
      LICname=envStr;
      uiIsOctave = true;
      break   
   end
   if strcmpi(envStr,'matlab')
      LICname=envStr
      uiIsMatlab = true;
      break
   end

end
if uiIsMatlab
   soln =  ode15s(@egfr_plx_ODE_system_aux,[tinit tend],egfr_plx_ODE_system_init(),options);
soln.y=soln.y';
elseif uiIsOctave
   soln = ode2r(@egfr_plx_ODE_system_aux,[tinit tend],egfr_plx_ODE_system_init(),options);
end
t = linspace(tinit, tend, num_t_point+1);
nrows = length(soln.x);
nobs = 2;
nfragments = 83;
tmp = zeros(nfragments,1);
obs = zeros (nrows,nobs);

for j=1:nrows
   for i=1:nfragments
      z(i)=soln.y(j,i);
   end
   h=egfr_plx_ODE_system_obs(z);
   for i=1:nobs
      obs(j,i)=h(i);
  end
end

if nobs==1
   y = interp1(soln.x, obs, t, 'pchip')';
else   y = interp1(soln.x, obs, t, 'pchip');
end


filename = 'egfr_plx.data';
fid = fopen (filename,'w');
for j=1:num_t_point+1
    fprintf(fid,'%f',t(j));
    for i=1:nobs
      fprintf(fid,' %f',y(j,i));
    end
    fprintf(fid,'\n');
end
fclose(fid);
filename = 'egfr_plx_ODE.xml';
fid = fopen (filename,'w');
fprintf(fid,'<?xml version=''1.0'' encoding=''utf-8''?>\n<!-- Automaticaly generated by Complx 4.321..10518-->\n');
fprintf(fid,'<!-- and postprocessed by %s -->\n',LICname);
fprintf(fid,'<ComplxSession Timestamp="01/29/2010 (10:51:21)" CommandLine="complx egfr.ka --output-scheme egfr --do-ODE" InputFile="egfr.ka" \nxsi:schemaLocation=\"http://plectix.synthesisstudios.com\nKappaSession.xsd\"\nxmlns=\"http://plectix.synthesisstudios.com/schemas/kappasession\"\nxmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" >\n');
fprintf(fid,'<Simulation TotalTime="%f" InitTime="%f">\n',tend,tinit);
fprintf(fid,'<Plot Type="OBSERVABLE" Text="%s"/>\n','[EGFR(Y48!0),SHC(Y7!1,pi!0),GRB2(a!1,b!2),SOS(d!2)]');
fprintf(fid,'<Plot Type="OBSERVABLE" Text="%s"/>\n','[EGFR(Y68!0),GRB2(a!0,b!1),SOS(d!1)]');
fprintf(fid,'<CSV>\n<![CDATA[\n');
for j=1:num_t_point+1
    fprintf(fid,'%f,',t(j));
    for i=1:nobs-1
      fprintf(fid,' %f,',y(j,i));
    end
    fprintf(fid,' %f',y(j,nobs));
    fprintf(fid,'\n');
end
fprintf(fid,']]>\n</CSV>\n</Simulation>\n');
fprintf(fid,'</ComplxSession>\n');
fclose(fid);